package com.shcd.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.Date;

import lombok.Data;

/**
 * 上海市长江经济带船舶使用岸电情况报表
 * @TableName SP_STATEMENT_SHIP_USAGE_MONTH
 */
@TableName(value ="GHJG_PORT_MANAGE.SP_STATEMENT_SHIP_USAGE_MONTH")
@Data
public class SpStatementShipUsageMonth implements Serializable {
    /**
     * 月份
     */
    @TableField(value = "REPORT_DATE")
    private Date reportDate;

    /**
     * 使用按段船舶（艘次）当年
     */
    @TableField(value = "SHIP_USAGE_YEAR")
    private BigDecimal shipUsageYear;

    /**
     * 使用岸电时间(小时) 当月
     */
    @TableField(value = "SHORE_POWER_TIME_MONTH")
    private BigDecimal shorePowerTimeMonth;

    /**
     * 使用岸电时间(小时)当年
     */
    @TableField(value = "SHORE_POWER_TIME_YEAR")
    private BigDecimal shorePowerTimeYear;

    /**
     * 使用岸电电量(kWh)当月
     */
    @TableField(value = "SHORE_POWER_COUNT_MONTH")
    private BigDecimal shorePowerCountMonth;

    /**
     * 使用岸电电量(kWh)当年
     */
    @TableField(value = "SHORE_POWER_COUNT_YEAR")
    private BigDecimal shorePowerCountYear;

    /**
     * 0 市级平台原始数据，10港航部门报送数据， 20线下报送数据 99报送交通委数据，100及以后为其他类型数据
     */
    @TableField(value = "DATA_SOURCE")
    private Integer dataSource;

    /**
     * 使用按段船舶（艘次）当月
     */
    @TableField(value = "SHIP_USAGE_MONTH")
    private BigDecimal shipUsageMonth;

    @TableId(value = "ID")
    private String id;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}